src/Entity/User.php
<?php
declare(strict_types=1);

namespace App\Entity;

use App\Repository\UserRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Security\Core\User\UserInterface;

/**
 * @ORM\Entity(repositoryClass=UserRepository::class)
 */
class User implements UserInterface
{
    /**
     * Constructor
     */
    public function __construct()
    {
        $this->roles = new \Doctrine\Common\Collections\ArrayCollection();
    }

    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=128, unique=true)
     */
    private $email;

    /**
     * @ORM\Column(type="string", length=512)
     */
    private $first_name;

    /**
     * @ORM\Column(type="string", length=512)
     */
    private $last_name;

    /**
     * @ORM\Column(type="string", length=256)
     */
    private $password;

    /**
     * @ORM\Column(type="datetime")
     */
    private $date_created;

    /**
    * @var Collection|Role[]
    * @ORM\ManyToMany(targetEntity="Role")
    * @ORM\JoinTable(
    *      name="user_roles",
    *      joinColumns={@ORM\JoinColumn(name="user_id", referencedColumnName="id")},
    *      inverseJoinColumns={@ORM\JoinColumn(name="role_id", referencedColumnName="id")}
    * )
     */
    private $roles;

    private $user_roles;

	/**
	 * @return int|null
	 */
    public function getId(): ?int
    {
        return $this->id;
    }

	/**
	 * @return string|null
	 */
    public function getEmail(): ?string
    {
        return $this->email;
    }

	/**
	 * @param string $email
	 * @return $this
	 */
    public function setEmail(string $email): self
    {
        $this->email = $email;

        return $this;
    }

	/**
	 * @return string|null
	 */
    public function getFirstName(): ?string
    {
        return $this->first_name;
    }

	/**
	 * @param string $first_name
	 * @return $this
	 */
    public function setFirstName(string $first_name): self
    {
        $this->first_name = $first_name;

        return $this;
    }

	/**
	 * @return string|null
	 */
    public function getLastName(): ?string
    {
        return $this->last_name;
    }

	/**
	 * @param string $last_name
	 * @return $this
	 */
    public function setLastName(string $last_name): self
    {
        $this->last_name = $last_name;

        return $this;
    }

	/**
	 * @return string|null
	 */
    public function getPassword(): ?string
    {
        return $this->password;
    }

	/**
	 * @param string $password
	 * @return $this
	 */
    public function setPassword(string $password): self
    {

        $this->password = $password;

        return $this;
    }

	/**
	 * @return \DateTimeInterface|null
	 */
    public function getDateCreated(): ?\DateTimeInterface
    {
        return $this->date_created;
    }

	/**
	 * @param \DateTimeInterface $date_created
	 * @return $this
	 */
    public function setDateCreated(\DateTimeInterface $date_created): self
    {
        $this->date_created = $date_created;

        return $this;
    }

	/**
	 * @return string|null
	 */
	public function getUsername()
    {
        return $this->getEmail();
    }

    /**
     * @return int
     */
	public function getUserIdentifier(): int
    {
        return $this->getId();
    }

	public function getSalt(){}

	public function eraseCredentials(){}

    /*
    * @param Role $role
    * @return $this
    */
    public function addRole(Role $role): self
    {
        if (!$this->roles->contains($role)) {
            $this->roles[] = $role;
        }

        return $this;
    }

    /*
    * @param Role $role
    * @return $this
    */
    public function removeRole(Role $role): self
    {
        $this->roles->removeElement($role);

        return $this;
    }

    /*
    * @retrun array
    */
    public function getRoles(): array {
        $roles = [];
        foreach($this->roles as $role) {
            $roles[] = $role->getName();
        }

        return $roles;
    }

        /*
    * @param Role $role
    * @return $this
    */
    public function addUserRoles(Role $role): self
    {
        if (!$this->roles->contains($role)) {
            $this->roles[] = $role;
        }

        return $this;
    }

    /*
    * @param Role $role
    * @return $this
    */
    public function removeUserRoles(Role $role): self
    {
        $this->roles->removeElement($role);

        return $this;
    }

    public function getUserRoles()
    {
        return $this->roles;
    }
}

src/Form/UserType.php
<?php
declare(strict_types=1);

namespace App\Form;

use App\Entity\User;
use App\Entity\Role;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\EmailType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

/**
 * Class UserType
 * @package App\Form
 */
class UserType extends AbstractType
{
    /**
     * @param \Symfony\Component\Form\FormBuilderInterface $builder
     * @param array                                        $options
     */
    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('email', EmailType::class)
            ->add('first_name')
            ->add('last_name')
            ->add('password', RepeatedType::class, [
                'type'              => PasswordType::class,
                'mapped'            => false,
                'required'          => $options['password_required'],
                'first_options'     => array('label' => 'New password'),
                'second_options'    => array('label' => 'Confirm new password'),
                'invalid_message'   => 'The password fields must match.',
            ])
            ->add('roles', EntityType::class, [
                'class' => Role::class,
                'property_path' => 'user_roles',
                'choice_label' => 'name',
            
                // used to render a select box, check boxes or radios
                'multiple' => true,
                // 'expanded' => true,
            ]);
    }

    /**
     * @param \Symfony\Component\OptionsResolver\OptionsResolver $resolver
     */
    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => User::class,
            'password_required'=>true
        ]);
    }
}

src/Controller/UserController.php
<?php
declare(strict_types=1);

namespace App\Controller;

use App\Entity\User;
use App\Form\UserType;
use App\Repository\UserRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\Security\Core\Encoder\UserPasswordEncoderInterface;

/**
 * @Route("/users")
 */
class UserController extends AbstractController
{
    /**
     * @Route("/", name="user_index", methods={"GET"})
     */
    public function index(UserRepository $userRepository): Response
    {
        return $this->render('user/index.html.twig', [
            'users' => $userRepository->findAll(),
        ]);
    }

    /**
     * @Route("/new", name="user_new", methods={"GET","POST"})
     */
    public function new(Request $request, UserPasswordEncoderInterface $userPasswordEncoder): Response
    {
        $user = new User();
        $form = $this->createForm(UserType::class, $user);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $entityManager = $this->getDoctrine()->getManager();
            $user->setDateCreated(\DateTime::createFromFormat('Y-m-d H:i:s', date('Y-m-d H:i:s')));
            $user->setPassword($userPasswordEncoder->encodePassword($user, $form->get('password')->getData()));
            $entityManager->persist($user);
            $entityManager->flush();

            return $this->redirectToRoute('user_index');
        }

        return $this->render('user/new.html.twig', [
            'user' => $user,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="user_show", methods={"GET"})
     */
    public function show(User $user): Response
    {
        return $this->render('user/show.html.twig', [
            'user' => $user,
        ]);
    }

    /**
     * @Route("/{id}/edit", name="user_edit", methods={"GET","POST"})
     */
    public function edit(Request $request, User $user, UserPasswordEncoderInterface $userPasswordEncoder): Response
    {
        $form = $this->createForm(UserType::class, $user, array('password_required' => false));
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            if(!empty($form->get('password')->getData())) {
                $user->setPassword($userPasswordEncoder->encodePassword($user, $form->get('password')->getData()));
            }
            $this->getDoctrine()->getManager()->flush();

            return $this->redirectToRoute('user_index');
        }

        return $this->render('user/edit.html.twig', [
            'user' => $user,
            'form' => $form->createView(),
        ]);
    }

    /**
     * @Route("/{id}", name="user_delete", methods={"GET","POST"})
     */
    public function delete(Request $request, User $user): Response
    {
        if ($this->isCsrfTokenValid('delete'.$user->getId(), $request->request->get('_token'))) {
            $entityManager = $this->getDoctrine()->getManager();
            $entityManager->remove($user);
            $entityManager->flush();
        }

        return $this->redirectToRoute('user_index');
    }
}

templates/user/_delete_form.html.twig
<form method="post" action="{{ path('user_delete', {'id': user.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ user.id) }}">
    <button class="btn btn-danger">Delete</button>
</form>

templates/user/_form.html.twig
{{ form_start(form) }}
    <div class="form-group">
        <div class="row">
            <div class="col-md-2">
                {{ form_label(form.email) }}
            </div>
            <div class="col-md-8">
                {{ form_widget(form.email) }}
            </div>
        </div>
        <small>{{ form_help(form.email) }}</small>
        <div class="form-error">
            {{ form_errors(form.email) }}
        </div>
    </div>
    <div class="form-group">
        <div class="row">
            <div class="col-md-2">
                {{ form_label(form.first_name) }}
            </div>
            <div class="col-md-8">
                {{ form_widget(form.first_name) }}
            </div>
        </div>
        <small>{{ form_help(form.first_name) }}</small>
        <div class="form-error">
            {{ form_errors(form.first_name) }}
        </div>
    </div>
    <div class="form-group">
        <div class="row">
            <div class="col-md-2">
                {{ form_label(form.last_name) }}
            </div>
            <div class="col-md-8">
                {{ form_widget(form.last_name) }}
            </div>
        </div>
        <small>{{ form_help(form.last_name) }}</small>
        <div class="form-error">
            {{ form_errors(form.last_name) }}
        </div>
    </div>
    <div class="form-group">
        <div class="row">
            <div class="col-md-2">
                {{ form_label(form.roles) }}
            </div>
            <div class="col-md-8">
                {{ form_widget(form.roles) }}
            </div>
        </div>
        <small>{{ form_help(form.roles) }}</small>
        <div class="form-error">
            {{ form_errors(form.roles) }}
        </div>
    </div>
    <div class="form-group">
        <div class="row">
            <div class="col-md-2">
                {{ form_label(form.password.first) }}
            </div>
            <div class="col-md-8">
                {{ form_widget(form.password.first) }}
            </div>
        </div>
        <small>{{ form_help(form.password.first) }}</small>
        <div class="form-error">
            {{ form_errors(form.password.first) }}
        </div>
    </div>
    <div class="form-group">
        <div class="row">
            <div class="col-md-2">
                {{ form_label(form.password.second) }}
            </div>
            <div class="col-md-8">
                {{ form_widget(form.password.second) }}
            </div>
        </div>
        <small>{{ form_help(form.password.second) }}</small>
        <div class="form-error">
            {{ form_errors(form.password.second) }}
        </div>
    </div>
    {{ form_row(form._token) }}
    <div class="row">
    <button class="btn btn-success">{{ button_label|default('Save') }}</button>
    <button class="btn btn-light" onclick="return window.location = '{{ path('user_index') }}'">Cancel</button>
    </div>
{{ form_end(form) }}

templates/user/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit User{% endblock %}

{% block body %}
    <h1>Edit User</h1>
<div class="row">
    <div class="col-md-12">
    {{ include('user/_form.html.twig', {'button_label': 'Update'}) }}
    </div>
</div>
{% endblock %}

templates/user/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Manage Users{% endblock %}

{% block body %}
    <h1>Manage Users</h1>
    <p>
        <a class="btn btn-primary" href="{{ path('user_new') }}">
            <span class="glyphicon glyphicon-plus" aria-hidden="true"></span> Create new
        </a>
    </p>

    <table class="table table-striped">
        <tr>
            <th>ID</th>
            <th>E-mail</th>
            <th>Full Name</th>
            <th>Date Created</th>
            <th>Actions</th>
        </tr>
        <tbody>
        {% for user in users %}
            <tr>
                <td>{{ user.id }}</td>
                <td>{{ user.email }}</td>
                <td>{{ user.firstName }} {{ user.lastName }}</td>
                <td>{{ user.dateCreated ? user.dateCreated|date('Y-m-d H:i:s') : '' }}</td>
                <td>
                    <a class="btn btn-secondary" href="{{ path('user_show', {'id': user.id}) }}">
                        <span class="glyphicon glyphicon-pencil" ></span> Show
                    </a>
                    <a class="btn btn-info" href="{{ path('user_edit', {'id': user.id}) }}">
                        <span class="glyphicon glyphicon-pencil"></span> Edit
                    </a>
                    <a class="btn btn-danger" href="{{ path('user_delete', {'id': user.id}) }}">
                        <span class="glyphicon glyphicon-remove"></span> Delete
                    </a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="7">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>
{% endblock %}

templates/user/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New User{% endblock %}

{% block body %}
    <h1>Create new User</h1>
    <div class="row">
        <div class="col-md-12">
        {{ include('user/_form.html.twig') }}
        </div>
    </div>
{% endblock %}

templates/user/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}User{% endblock %}

{% block body %}
    <h1>User</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ user.id }}</td>
            </tr>
            <tr>
                <th>Email</th>
                <td>{{ user.email }}</td>
            </tr>
            <tr>
                <th>First name</th>
                <td>{{ user.firstName }}</td>
            </tr>
            <tr>
                <th>Last name</th>
                <td>{{ user.lastName }}</td>
            </tr>
            <tr>
                <th>Date created</th>
                <td>{{ user.dateCreated ? user.dateCreated|date('Y-m-d H:i:s') : '' }}</td>
            </tr>
        </tbody>
    </table>

    <a href="{{ path('user_index') }}">back to list</a>

    <a href="{{ path('user_edit', {'id': user.id}) }}">edit</a>

    {{ include('user/_delete_form.html.twig') }}
{% endblock %}